Index: admin/js/_media.js
===================================================================
--- admin/js/_media.js	(revision 3989)
+++ admin/js/_media.js	(revision 0)
@@ -1,222 +1,80 @@
-/*global $, jQuery, dotclear, template_upload, template_download */
-'use strict';
-
-(function($) {
-  $.fn.enhancedUploader = function() {
-    return this.each(function() {
-      const me = $(this);
-      const $container = $(me).parent();
-
-      function enableButton(button) {
-        button.prop('disabled', false).removeClass('disabled');
-      }
-
-      function disableButton(button) {
-        button.prop('disabled', true).addClass('disabled');
-      }
-
-      function displayMessageInQueue(n) {
-        let msg = '';
-        if (n == 1) {
-          msg = dotclear.jsUpload.msg.file_in_queue;
-        } else if (n > 1) {
-          msg = dotclear.jsUpload.msg.files_in_queue;
-          msg = msg.replace(/%d/, n);
-        } else {
-          msg = dotclear.jsUpload.msg.no_file_in_queue;
-        }
-        $('.queue-message', me).html(msg);
-      }
-
-      $('.button.choose_files').click(function(e) {
-        if ($container.hasClass('enhanced_uploader')) {
-          // Use the native click() of the file input.
-          $('#upfile').click();
-          e.preventDefault();
-        }
-      });
-
-      $('.button.cancel', '#fileupload .fileupload-buttonbar').click(function() {
-        $('.button.cancel', '#fileupload .fileupload-buttonbar').hide();
-        disableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-        displayMessageInQueue(0);
-      });
-
-      $(me).on('click', '.cancel', function() {
-        if ($('.fileupload-ctrl .files .template-upload', me).length == 0) {
-          $('.button.cancel', '#fileupload .fileupload-buttonbar').hide();
-          disableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-        }
-        displayMessageInQueue($('.files .template-upload', me).length);
-      });
-
-      $('.button.clean', me).click(function(e) {
-        $('.fileupload-ctrl .files .template-download', me).slideUp(500, function() {
-          $(this).remove();
-        });
-        $(this).hide();
-        e.preventDefault();
-      });
-
-      $(me).fileupload({
-        url: $(me).attr('action'),
-        autoUpload: false,
-        sequentialUploads: true,
-        uploadTemplateId: null,
-        downloadTemplateId: null,
-        uploadTemplate: template_upload,
-        downloadTemplate: template_download
-      }).bind('fileuploadadd', function() {
-        $('.button.cancel').css('display', 'inline-block');
-        $('#fileupload .fileupload-buttonbar').show();
-        enableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-      }).bind('fileuploadadded', function() {
-        displayMessageInQueue($('.files .template-upload', me).length);
-      }).bind('fileuploaddone', function(e, data) {
-        if (data.result.files[0].html !== undefined) {
-          $('.media-list .files-group').append(data.result.files[0].html);
-          $('#form-medias .hide').removeClass('hide');
-        }
-        $('.button.clean').css('display', 'inline-block');
-        $(me).show();
-      }).bind('fileuploadalways', function() {
-        displayMessageInQueue($('.files .template-upload', me).length);
-        if ($('.fileupload-ctrl .files .template-upload', me).length == 0) {
-          $('.button.cancel', '#fileupload .fileupload-buttonbar').hide();
-          disableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-        }
-      });
-
-      let $msg;
-      let label;
-
-      if ($container.hasClass('enhanced_uploader')) {
-        $msg = dotclear.msg.enhanced_uploader_disable;
-        label = dotclear.jsUpload.msg.choose_files;
-        $(me).fileupload({
-          disabled: false
-        });
-        displayMessageInQueue(0);
-        disableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-      } else {
-        $msg = dotclear.msg.enhanced_uploader_activate;
-        label = dotclear.jsUpload.msg.choose_file;
-        $(me).fileupload({
-          disabled: true
-        });
-      }
-
-      $(`<p class="clear"><button type="button" class="enhanced-toggle">${$msg}</button></p>`).click(function(e) {
-        if ($container.hasClass('enhanced_uploader')) {
-          $msg = dotclear.msg.enhanced_uploader_activate;
-          label = dotclear.jsUpload.msg.choose_file;
-          $('#upfile').attr('multiple', false);
-          enableButton($('.button.start', '#fileupload .fileupload-buttonbar'));
-
-          // when a user has clicked enhanced_uploader, and has added files
-          // We must remove files in table
-          $('.files .upload-file', me).remove();
-          $('.button.cancel,.button.clean', '#fileupload .fileupload-buttonbar').hide();
-          $(me).fileupload({
-            disabled: true
-          });
-          $('.queue-message', me).html('').hide();
-        } else {
-          $msg = dotclear.msg.enhanced_uploader_disable;
-          label = dotclear.jsUpload.msg.choose_files;
-          $('#upfile').attr('multiple', true);
-          const startButton = $('.button.start');
-          const buttonBar = $('#fileupload .fileupload-buttonbar');
-          disableButton(startButton);
-          disableButton(buttonBar);
-          startButton.css('display', 'inline-block');
-          buttonBar.show();
-          $(me).fileupload({
-            disabled: false
-          });
-          $('.queue-message', me).show();
-          displayMessageInQueue(0);
-        }
-        $(this).find('button').text($msg);
-        $('.add-label', me).text(label);
-
-        $container.toggleClass('enhanced_uploader');
-        e.preventDefault();
-      }).appendTo(me);
-    });
-  };
-})(jQuery);
-
 $(function() {
-  $('#fileupload').enhancedUploader();
-
-  $('.checkboxes-helpers').each(function() {
-    dotclear.checkboxesHelpers(this, undefined, '#form-medias input[type="checkbox"]', '#form-medias #delete_medias');
-  });
-  dotclear.condSubmit('#form-medias input[type="checkbox"]', '#form-medias #delete_medias');
-
-  $('#form-medias #delete_medias').click(function(e) {
-    const count_checked = $('input[name="medias[]"]:checked', $('#form-medias')).length;
-    if (count_checked == 0) {
-      e.preventDefault();
-      return false;
-    }
-    return window.confirm(dotclear.msg.confirm_delete_medias.replace('%d', count_checked));
-  });
-
-  // Preview media
-  $('.modal-image').magnificPopup({
-    type: 'image'
-  });
-
-  // attach media
-  $('#form-medias').on('click', '.media-item .attach-media', function(e) {
-    const parts = $(this).prop('href').split('?');
-    const str_params = parts[1].split('&');
-    let postData = {};
-
-    for (let n = 0; n < str_params.length; n++) {
-      const kv = str_params[n].split('=');
-      postData[kv[0]] = kv[1];
-    }
-    postData.xd_check = dotclear.nonce;
-
-    $.post(parts[0], postData, function(data) {
-      if (data.url !== undefined) {
-        document.location = data.url;
-      }
-    });
-
-    e.preventDefault();
-  });
-
-  // Replace remove links by a POST on hidden form
-  fileRemoveAct();
-
-  function fileRemoveAct() {
-    $('body').on('click', 'a.media-remove', function() {
-      const m_name = $(this).parents('.media-item').find('a.media-link').text();
-      let m_text = '';
-      if ($(this).parents('div.media-folder').length == 0) {
-        m_text = dotclear.msg.confirm_delete_media.replace('%s', m_name);
-      } else {
-        m_text = dotclear.msg.confirm_delete_directory.replace('%s', m_name);
-      }
-      if (window.confirm(m_text)) {
-        const f = $('#media-remove-hide').get(0);
-        f.elements.remove.value = this.href.replace(/^(.*)&remove=(.*?)(&|$)/, '$2');
-        this.href = '';
-        f.submit();
-      }
-      return false;
-    });
-  }
-
-  // Switch folder
-  const urlmenu = document.getElementById('switchfolder');
-  if (urlmenu) {
-    urlmenu.onchange = function() {
-      window.location = this.options[this.selectedIndex].value;
-    };
-  }
+	// Replace remove links by a POST on hidden form
+	fileRemoveAct();
+	
+	function fileRemoveAct() {
+		$('a.media-remove').click(function() {
+			var m_name = $(this).parents('ul').find('li:first>a').text();
+			if (window.confirm(dotclear.msg.confirm_delete_media.replace('%s',m_name))) {
+				var f = $('#media-remove-hide').get(0);
+				f.elements['remove'].value = this.href.replace(/^(.*)&remove=(.*?)(&|$)/,'$2');
+				this.href = '';
+				f.submit();
+			}
+			return false;
+		});
+	}
+	
+	if (!$.browser.opera) {
+		var upldr = $('<a href="#">' + dotclear.msg.activate_enhanced_uploader + '</a>')
+		.click(function() {
+			candyUploadInit();
+			return false;
+		});
+		$('#media-upload>fieldset').append($('<div></div>').append(upldr));
+		
+		if ($.cookie('dc_candy_upl') == 1) {
+			candyUploadInit();
+		}
+	}
+	
+	function candyUploadInit()
+	{
+		var candy_upload_success = false;
+		var candy_upload_form_url = $('#media-upload').attr('action') + '&file_sort=date-desc&d=' + $('#media-upload input[name=d]').val();
+		var candy_upload_limit = $('#media-upload input[name=MAX_FILE_SIZE]').val();
+		$('#media-upload').candyUpload({
+			upload_url: dotclear.candyUpload.base_url + '/media.php',
+			flash_movie: dotclear.candyUpload.movie_url,
+			file_size_limit: candy_upload_limit + 'b',
+			params: 'swfupload=1&amp;' + dotclear.candyUpload.params,
+			
+			callbacks: {
+				createControls: function() {
+					var _this = this;
+					var l = $('<a href="#">' + dotclear.msg.disable_enhanced_uploader + '</a>').click(function() {
+						_this.upldr.destroy();
+						_this.ctrl.block.empty().remove();
+						$('#media-upload').show();
+						delete _this;
+						$.cookie('dc_candy_upl','',{expires: -1});
+						return false;
+					});
+					this.ctrl.disable = $('<div class="cu-disable"></div>').append(l).appendTo(this.ctrl.block);
+				},
+				flashReady: function() {
+					this.ctrl.btn_browse.addClass('button');
+					this.ctrl.block.append(this.ctrl.disable);
+				},
+				uploadSuccess: function(o,data) {
+					if (data == 'ok') {
+						candy_upload_success = true;
+						this.fileMsg(o.id,this.locales.file_uploaded);
+					} else {
+						this.fileErrorMsg(o.id,data);
+					}
+					
+					// uploads finished and at least one success
+					if (candy_upload_success && $('div.cu-file:has(span.cu-filecancel a)',this.ctrl.files).length == 0) {
+						$.cookie('dc_candy_upl','1',{expires: 30});
+						$.get(candy_upload_form_url,function(data) {
+							var media = $('div.media-list');
+							media.after($('div.media-list',data)).remove();
+							fileRemoveAct();
+						});
+					}
+				}
+			}
+		});
+	}
 });
Index: admin/js/_media_item.js
===================================================================
--- admin/js/_media_item.js	(revision 3957)
+++ admin/js/_media_item.js	(revision 0)
@@ -1,96 +1,65 @@
-/*global $, dotclear, datePicker */
-'use strict';
-
 $(function() {
-  // Add datePicker if possible
-  const media_dt = document.getElementById('media_dt');
-  if (media_dt != undefined) {
-    const post_dtPick = new datePicker(media_dt);
-    post_dtPick.img_top = '1.5em';
-    post_dtPick.draw();
-  }
-
-  // Preview media
-  $('.modal-image').magnificPopup({
-    type: 'image'
-  });
-
-  // Display zip file content
-  $('#file-unzip').each(function() {
-    const a = document.createElement('a');
-    const mediaId = $(this).find('input[name=id]').val();
-    const This = $(this);
-
-    a.href = '#';
-    $(a).text(dotclear.msg.zip_file_content);
-    This.before(a);
-    $(a).wrap('<p></p>');
-
-    $(a).click(function() {
-      $.get('services.php', {
-        f: 'getZipMediaContent',
-        id: mediaId
-      }, function(data) {
-        const rsp = $(data).children('rsp')[0];
-
-        if (rsp.attributes[0].value == 'ok') {
-          const div = document.createElement('div');
-          const list = document.createElement('ul');
-          let expanded = false;
-
-          $(div).css({
-            overflow: 'auto',
-            margin: '1em 0',
-            padding: '1px 0.5em'
-          });
-          $(div).addClass('color-div');
-          $(div).append(list);
-          This.before(div);
-          $(a).hide();
-          $(div).before('<h3>' + dotclear.msg.zip_file_content + '</h3>');
-
-          $(rsp).find('file').each(function() {
-            $(list).append('<li>' + $(this).text() + '</li>');
-            if ($(div).height() > 200 && !expanded) {
-              $(div).css({
-                height: '200px'
-              });
-              expanded = true;
-            }
-          });
-        } else {
-          window.alert($(rsp).find('message').text());
-        }
-      });
-      return false;
-    });
-  });
-
-  // Confirm for inflating in current directory
-  $('#file-unzip').submit(function() {
-    if ($(this).find('#inflate_mode').val() == 'current') {
-      return window.confirm(dotclear.msg.confirm_extract_current);
-    }
-    return true;
-  });
-
-  // Confirm for deleting current medoa
-  $('#delete-form input[name="delete"]').click(function() {
-    let m_name = $('#delete-form input[name="remove"]').val();
-    return window.confirm(dotclear.msg.confirm_delete_media.replace('%s', m_name));
-  });
-
-  // Get current insertion settings
-  $('#save_settings').submit(function() {
-    $('input[name="pref_src"]').val($('input[name="src"][type=radio]:checked').attr('value'));
-    $('input[name="pref_alignment"]').val($('input[name="alignment"][type=radio]:checked').attr('value'));
-    $('input[name="pref_insertion"]').val($('input[name="insertion"][type=radio]:checked').attr('value'));
-    $('input[name="pref_legend"]').val($('input[name="legend"][type=radio]:checked').attr('value'));
-  });
-
-  // Set focus if in popup mode
-  $('#media-insert-form :input:visible:enabled:checked:first, #media-insert-form :input:visible:enabled:first').focus();
-
-  // Deal with enter key on media insert popup form : every form element will be filtered but Cancel button
-  dotclear.enterKeyInForm('#media-insert-form', '#media-insert-ok', '#media-insert-cancel');
+	$('#media-details-tab').onetabload(function() {
+		// Add date picker
+		var media_dt = document.getElementById('media_dt');
+		if (media_dt == undefined) { return; }
+		var post_dtPick = new datePicker(media_dt);
+		post_dtPick.img_top = '1.5em';
+		post_dtPick.draw();
+	});
+	
+	// Display zip file content
+	$('#file-unzip').each(function() {
+		var a = document.createElement('a');
+		var mediaId = $(this).find('input[name=id]').val();
+		var self = $(this);
+		
+		a.href = '#';
+		$(a).text(dotclear.msg.zip_file_content);
+		self.before(a);
+		$(a).wrap('<p></p>');
+		
+		$(a).click(function() {
+			$.get('services.php',{f:'getZipMediaContent',id: mediaId},function(data) {
+				var rsp = $(data).children('rsp')[0];
+				
+				if (rsp.attributes[0].value == 'ok') {
+					var div = document.createElement('div');
+					var list = document.createElement('ul');
+					var expanded = false;
+					
+					$(div).css({
+						overflow: 'auto',
+						border: '1px solid #ccc',
+						margin: '1em 0',
+						padding: '1px 0.5em'
+					});
+					
+					$(div).append(list);
+					self.before(div);
+					$(a).hide();
+					$(div).before('<h3>' + dotclear.msg.zip_file_content + '</h3>');
+					
+					$(rsp).find('file').each(function() {
+						$(list).append('<li>' + $(this).text() + '</li>');
+						if ($(div).height() > 200 && !expanded) {
+							$(div).css({height: '200px'});
+							expanded = true;
+						}
+					});
+				} else {
+					alert($(rsp).find('message').text());
+				}
+			});
+			return false;
+		});
+	});
+	
+	// Confirm for inflating in current directory
+	$('#file-unzip').submit(function() {
+		if ($(this).find('#inflate_mode').val() == 'current') {
+			return window.confirm(dotclear.msg.confirm_extract_current);
+		}
+		return true;
+	});
 });
Index: admin/js/_permissions.js
===================================================================
--- admin/js/_permissions.js	(revision 0)
+++ admin/js/_permissions.js	(revision 0)
@@ -0,0 +1,56 @@
+jQuery.fn.updatePermissionsForm = function() {
+	return this.each(function() {
+		var perms = {};
+		var re = /^perm\[(.+?)\]\[(.+?)\]$/;
+		var e,prop;
+		
+		// Building a nice object of form elements
+		for (var i=0; i<this.elements.length; i++) {
+			e = this.elements[i];
+			
+			if (e.name == undefined) {
+				continue;
+			}
+			prop = e.name.match(re);
+			if (!prop) {
+				continue;
+			}
+			if (perms[prop[1]] == undefined) {
+				perms[prop[1]] = {};
+			}
+			perms[prop[1]][prop[2]] = e;
+		}
+		
+		// Update elements status
+		var E;
+		for (blog in perms) {
+			for (perm in perms[blog]) {
+				E = perms[blog][perm];
+				E.onclick = function() {};
+				
+				if (perm == 'admin' && !E.disabled) {
+					perms[blog]['usage'].disabled = E.checked;
+					perms[blog]['publish'].disabled = E.checked;
+					perms[blog]['delete'].disabled = E.checked;
+					perms[blog]['contentadmin'].disabled = E.checked;
+					perms[blog]['categories'].disabled = E.checked;
+					perms[blog]['media'].disabled = E.checked;
+					perms[blog]['media_admin'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				} else if (perm == 'contentadmin' && !E.disabled) {
+					perms[blog]['usage'].disabled = E.checked;
+					perms[blog]['publish'].disabled = E.checked;
+					perms[blog]['delete'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				} else if (perm == 'media_admin' && !E.disabled) {
+					perms[blog]['media'].disabled = E.checked;
+					E.onclick = function() { $(this.form).updatePermissionsForm(); };
+				}
+			}
+		}
+	});
+};
+
+$(function() {
+	$('#permissions-form').updatePermissionsForm();
+});
Index: admin/js/_permissions_blog.js
===================================================================
--- admin/js/_permissions_blog.js	(revision 0)
+++ admin/js/_permissions_blog.js	(revision 0)
@@ -0,0 +1,5 @@
+$(function() {
+	$('.checkboxes-helpers').each(function() {
+		dotclear.checkboxesHelpers(this);
+	});
+});
Index: admin/js/_plugins.js
===================================================================
--- admin/js/_plugins.js	(revision 3880)
+++ admin/js/_plugins.js	(revision 0)
@@ -1,73 +1,6 @@
-/*global $, dotclear */
-'use strict';
-
 $(function() {
-  // expand a module line
-  $('table.modules.expandable tr.line').each(function() {
-    $('td.module-name, th.module-name', this).toggleWithLegend($(this).next('.module-more'), {
-      img_on_txt: dotclear.img_plus_txt,
-      img_on_alt: dotclear.img_plus_alt,
-      img_off_txt: dotclear.img_minus_txt,
-      img_off_alt: dotclear.img_minus_alt,
-      legend_click: true
-    });
-  });
-
-  // checkboxes selection
-  $('.checkboxes-helpers').each(function() {
-    dotclear.checkboxesHelpers(this);
-  });
-
-  // actions tests
-  $('.modules-form-actions').each(function() {
-    const rxActionType = /^[^\[]+/;
-    const rxActionValue = /([^\[]+)\]$/;
-    const checkboxes = $(this).find('input[type=checkbox]');
-
-    // check if submit is a global action or one line action
-    $('input[type=submit]', this).click(function() {
-      const keyword = $(this).attr('name');
-      if (!keyword) {
-        return true;
-      }
-      const maction = keyword.match(rxActionType);
-      const action = maction[0];
-      const mvalues = keyword.match(rxActionValue);
-
-      // action on multiple modules
-      if (!mvalues) {
-        let checked = false;
-
-        // check if there is checkboxes in form
-        if (checkboxes.length > 0) {
-          // check if there is at least one checkbox checked
-          $(checkboxes).each(function() {
-            if (this.checked) {
-              checked = true;
-            }
-          });
-          if (!checked) {
-            //alert(dotclear.msg.no_selection);
-            return false;
-          }
-        }
-
-        // confirm delete
-        if (action == 'delete') {
-          return window.confirm(dotclear.msg.confirm_delete_plugins);
-        }
-
-        // action on one module
-      } else {
-        const module = mvalues[1];
-
-        // confirm delete
-        if (action == 'delete') {
-          return window.confirm(dotclear.msg.confirm_delete_plugin.replace('%s', module));
-        }
-      }
-
-      return true;
-    });
-  });
+	$('table.plugins form input[type=submit][name=delete]').click(function() {
+		var p_name = $('input[name=plugin_id]',$(this).parent()).val();
+		return window.confirm(dotclear.msg.confirm_delete_plugin.replace('%s',p_name));
+	});
 });
